import json
import os
import shutil

CONFIG_SV = """[fcgi-program:rapida_reface]
command=daphne -u /run/rapida_reface.sock --fd 0 --access-log - --proxy-headers reface.asgi:application
socket=tcp://localhost:55581
;socket_owner=chrism
;socket_mode=0700
;process_name=%(program_name)s_%(process_num)02d
;numprocs=5
directory=/var/rapida
;umask=022
;priority=999
autostart=true
autorestart=true
startsecs=3
startretries=3
;exitcodes=0
stopsignal=QUIT
;stopasgroup=false
;killasgroup=false
stopwaitsecs=20
user=root
redirect_stderr=false
stdout_logfile=/var/log/rapida/reface_stdout.log
stdout_logfile_maxbytes=3MB
stdout_logfile_backups=10
;stdout_capture_maxbytes=1MB
;stdout_events_enabled=false
stderr_logfile=/var/log/rapida/reface_stderr.log
stderr_logfile_maxbytes=1MB
stderr_logfile_backups=10
;stderr_capture_maxbytes=1MB
;stderr_events_enabled=false
environment=
	REFACE_CONFIG=/etc/rapida/reface/config.json,
	DJANGO_SETTINGS_MODULE=reface.settings
;serverurl=AUTO
"""


CONFIG_SV_PATH = '/etc/supervisor/conf.d/rapida_reface.conf'
CONFIG_RF_PATH = '/etc/rapida/reface/config.json'
CONFIG_RF = {
    "dump": "/etc/rapida/reface/dump.json"
}


def reset(clear_data=False):
    if clear_data:
        shutil.rmtree('/etc/rapida/', ignore_errors=True)

    if not os.path.exists(os.path.dirname(CONFIG_RF_PATH)):
        os.mkdir(os.path.dirname(CONFIG_RF_PATH))

    with open(CONFIG_RF_PATH, 'w') as fs:
        json.dump(CONFIG_RF, fs, indent=4)

    if not os.path.exists(os.path.dirname(CONFIG_SV_PATH)):
        os.mkdir(os.path.dirname(CONFIG_SV_PATH))

    with open(CONFIG_SV_PATH, 'w') as fs:
        fs.write(CONFIG_SV)

    os.system('sudo supervisorctl reread')
    os.system('sudo supervisorctl update')
    os.system('sudo supervisorctl restart rapida_reface')


if __name__ == '__main__':
    reset()
